#!/bin/sh
PATH=/usr/bin:/bin
umask 022
tail_args="-n "
echo "Unpacking..."
outname=install.sfx.$$
trap 'rm -f $outname; exit 1' HUP INT QUIT TERM
tail ${tail_args}+16 $0 > $outname
chmod +x $outname
echo "Extracting..."
./$outname
echo "Executing..."
./install.sh
rm -f $outname
# Line 15 -- data follows!
#!/bin/sh
# This is a shell archive (produced by GNU sharutils 4.13.3).
# To extract the files from this archive, save it to some FILE, remove
# everything before the `#!/bin/sh' line above, then type `sh FILE'.
#
lock_dir=_sh24488
# Made on 2016-05-09 10:34 UTC by <root@yeltha-4>.
# Source directory was `/tmp/cli-rt-domu'.
#
# Existing files will *not* be overwritten, unless `-c' is specified.
#
# This shar contains:
# length mode       name
# ------ ---------- ------------------------------------------
#    535 -rwxr-xr-x install.sh
#   3421 -rw-r--r-- root/gtcomms.ml
#    992 -rw-r--r-- root/gtmessages.ml
#   2506 -rw-r--r-- root/gtserver_linux.ml
#   3806 -rw-r--r-- root/gtlinuxops.ml
#
MD5SUM=${MD5SUM-md5sum}
f=`${MD5SUM} --version | egrep '^md5sum .*(core|text)utils'`
test -n "${f}" && md5check=true || md5check=false
${md5check} || \
  echo 'Note: not verifying md5sums.  Consider installing GNU coreutils.'
if test "X$1" = "X-c"
then keep_file=''
else keep_file=true
fi
echo=echo
save_IFS="${IFS}"
IFS="${IFS}:"
gettext_dir=
locale_dir=
set_echo=false

for dir in $PATH
do
  if test -f $dir/gettext \
     && ($dir/gettext --version >/dev/null 2>&1)
  then
    case `$dir/gettext --version 2>&1 | sed 1q` in
      *GNU*) gettext_dir=$dir
      set_echo=true
      break ;;
    esac
  fi
done

if ${set_echo}
then
  set_echo=false
  for dir in $PATH
  do
    if test -f $dir/shar \
       && ($dir/shar --print-text-domain-dir >/dev/null 2>&1)
    then
      locale_dir=`$dir/shar --print-text-domain-dir`
      set_echo=true
      break
    fi
  done

  if ${set_echo}
  then
    TEXTDOMAINDIR=$locale_dir
    export TEXTDOMAINDIR
    TEXTDOMAIN=sharutils
    export TEXTDOMAIN
    echo="$gettext_dir/gettext -s"
  fi
fi
IFS="$save_IFS"
if (echo "testing\c"; echo 1,2,3) | grep c >/dev/null
then if (echo -n test; echo 1,2,3) | grep n >/dev/null
     then shar_n= shar_c='
'
     else shar_n=-n shar_c= ; fi
else shar_n= shar_c='\c' ; fi
f=shar-touch.$$
st1=200112312359.59
st2=123123592001.59
st2tr=123123592001.5 # old SysV 14-char limit
st3=1231235901

if   touch -am -t ${st1} ${f} >/dev/null 2>&1 && \
     test ! -f ${st1} && test -f ${f}; then
  shar_touch='touch -am -t $1$2$3$4$5$6.$7 "$8"'

elif touch -am ${st2} ${f} >/dev/null 2>&1 && \
     test ! -f ${st2} && test ! -f ${st2tr} && test -f ${f}; then
  shar_touch='touch -am $3$4$5$6$1$2.$7 "$8"'

elif touch -am ${st3} ${f} >/dev/null 2>&1 && \
     test ! -f ${st3} && test -f ${f}; then
  shar_touch='touch -am $3$4$5$6$2 "$8"'

else
  shar_touch=:
  echo
  ${echo} 'WARNING: not restoring timestamps.  Consider getting and
installing GNU `touch'\'', distributed in GNU coreutils...'
  echo
fi
rm -f ${st1} ${st2} ${st2tr} ${st3} ${f}
#
if test ! -d ${lock_dir} ; then :
else ${echo} "lock directory ${lock_dir} exists"
     exit 1
fi
if mkdir ${lock_dir}
then ${echo} "x - created lock directory ${lock_dir}."
else ${echo} "x - failed to create lock directory ${lock_dir}."
     exit 1
fi
# ============= install.sh ==============
if test -n "${keep_file}" && test -f 'install.sh'
then
${echo} "x - SKIPPING install.sh (file already exists)"

else
${echo} "x - extracting install.sh (text)"
  sed 's/^X//' << 'SHAR_EOF' > 'install.sh' &&
#!/bin/sh
X
# script which installs the CLI RT guest agent
export PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin
X
SRCDIR=`dirname $0`
cd $SRCDIR
X
apt-get update -y -q
apt-get install -y --force-yes -q ocaml dosfstools
X
cd /root
X
ocamlc -o gtserver unix.cma gtmessages.ml gtcomms.ml gtlinuxops.ml gtserver_linux.ml
X
echo "exec /root/gtserver &" > /etc/init.d/xapitest 
chmod 755 /etc/init.d/xapitest
/usr/sbin/update-rc.d xapitest defaults 99
X
rm /etc/udev/rules.d/z25* /etc/udev/rules.d/z45*
X
rm -f /etc/rc2.d/S99firstboot
X
poweroff
SHAR_EOF
  (set 20 16 05 09 10 34 56 'install.sh'
   eval "${shar_touch}") && \
  chmod 0755 'install.sh'
if test $? -ne 0
then ${echo} "restore of install.sh failed"
fi
  if ${md5check}
  then (
       ${MD5SUM} -c >/dev/null 2>&1 || ${echo} 'install.sh': 'MD5 check failed'
       ) << \SHAR_EOF
ed409e7188abae7ee3d0403518d11e64  install.sh
SHAR_EOF

else
test `LC_ALL=C wc -c < 'install.sh'` -ne 535 && \
  ${echo} "restoration warning:  size of 'install.sh' is not 535"
  fi
fi
# ============= root/gtcomms.ml ==============
if test ! -d 'root'; then
  mkdir 'root'
if test $? -eq 0
then ${echo} "x - created directory root."
else ${echo} "x - failed to create directory root."
     exit 1
fi
fi
if test -n "${keep_file}" && test -f 'root/gtcomms.ml'
then
${echo} "x - SKIPPING root/gtcomms.ml (file already exists)"

else
${echo} "x - extracting root/gtcomms.ml (text)"
  sed 's/^X//' << 'SHAR_EOF' > 'root/gtcomms.ml' &&
(*
X * Copyright (C) 2006-2009 Citrix Systems Inc.
X *
X * This program is free software; you can redistribute it and/or modify
X * it under the terms of the GNU Lesser General Public License as published
X * by the Free Software Foundation; version 2.1 only. with the special
X * exception on linking described in file LICENSE.
X *
X * This program is distributed in the hope that it will be useful,
X * but WITHOUT ANY WARRANTY; without even the implied warranty of
X * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
X * GNU Lesser General Public License for more details.
X *)
module type PROTOCOL =
X  sig
X    type t
X    val to_string : t -> string
X    val of_string : string -> t
X  end
X
module Make_Protocol = functor ( T : sig type t end ) ->
X  struct
X    type t=T.t
X    let to_string (x:t) = Marshal.to_string x [Marshal.Closures]
X    let of_string s = (Marshal.from_string s 0 : t)
X  end
X
let rec really_read s string off n =
X  if n=0 then () else
X    let m = Unix.read s string off n in
X    (if m = 0 then raise End_of_file);
X    really_read s string (off+m) (n-m)
X      
module Com = functor (P : PROTOCOL) ->
X  struct 
X    let send fd m =
X      let mes = P.to_string m in
X      let l = (string_of_int (String.length mes)) in
X      let buffer = String.make 12 ' ' in
X      for i=0 to (String.length l)-1 do buffer.[i] <- l.[i] done;
X      ignore(Unix.write fd buffer 0 12);
X      ignore(Unix.write fd mes 0 (String.length mes))
X      
X    let receive fd =
X      let buffer = String.make 12 ' '
X      in
X      try
X	ignore (really_read fd buffer 0 12);
X	let l=
X	  let i=ref 0 in 
X	  while(buffer.[!i]<>' ') do incr i done;
X	  int_of_string (String.sub buffer 0 !i)
X	in
X	Printf.fprintf stderr "Length of message: %d\n" l;
X	let buffer = String.create l
X	in 
X	(try
X	  ignore (really_read fd buffer 0 l);
X	with
X	    e -> 
X	      Printf.fprintf stderr "Exception: %s\nGot '%s' so far (%d bytes)" (Printexc.to_string e) buffer (String.length buffer);
X	      failwith "error");
X	P.of_string buffer
X      with e -> 
X	Printf.fprintf stderr "%s\n" (Printexc.to_string e);
X	raise (Failure ("Problem interpreting response: got '"^buffer^"'"))
X  end
X
module Server = functor (P : PROTOCOL) ->
X  struct 
X    module Com = Com(P)
X	
X    class virtual ['a] server p np =
X      object(s)
X	constraint 'a = P.t
X	val port_num = p
X	val nb_pending = np
X	val sock = Unix.socket Unix.PF_INET Unix.SOCK_STREAM 0
X
X	method start =
X	  Printf.printf "Starting...\n";
X	  let sock_addr = Unix.ADDR_INET(Unix.inet_addr_any,port_num) in
X	  Unix.bind sock sock_addr;
X	  Unix.listen sock nb_pending;
X	  while true do
X	    let (service_sock, client_sock_addr) = Unix.accept sock
X	    in ignore (s#process service_sock)
X	  done
X	method send = Com.send
X	method receive = Com.receive
X	method virtual process : Unix.file_descr -> unit
X      end
X  end
X
module Client = functor (P : PROTOCOL) ->
X  struct
X    module Com = Com(P)
X	
X    let connect addr port =
X      let sock = Unix.socket Unix.PF_INET Unix.SOCK_STREAM 0
X      and in_addr = (Unix.gethostbyname addr).Unix.h_addr_list.(0)
X      in Unix.connect sock (Unix.ADDR_INET(in_addr, port));
X      sock
X
X    let emit_simple addr port mes =
X      let sock = connect addr port
X      in Com.send sock mes; 
X      Unix.close sock
X     
X    let emit_answer addr port mes =
X      let sock = connect addr port
X      in Com.send sock mes;
X      let res = Com.receive sock
X      in Unix.close sock; res
X  end
SHAR_EOF
  (set 20 16 05 09 10 34 56 'root/gtcomms.ml'
   eval "${shar_touch}") && \
  chmod 0644 'root/gtcomms.ml'
if test $? -ne 0
then ${echo} "restore of root/gtcomms.ml failed"
fi
  if ${md5check}
  then (
       ${MD5SUM} -c >/dev/null 2>&1 || ${echo} 'root/gtcomms.ml': 'MD5 check failed'
       ) << \SHAR_EOF
d8c1ac4a42f2c91f00a07542ed148a29  root/gtcomms.ml
SHAR_EOF

else
test `LC_ALL=C wc -c < 'root/gtcomms.ml'` -ne 3421 && \
  ${echo} "restoration warning:  size of 'root/gtcomms.ml' is not 3421"
  fi
fi
# ============= root/gtmessages.ml ==============
if test ! -d 'root'; then
  mkdir 'root'
if test $? -eq 0
then ${echo} "x - created directory root."
else ${echo} "x - failed to create directory root."
     exit 1
fi
fi
if test -n "${keep_file}" && test -f 'root/gtmessages.ml'
then
${echo} "x - SKIPPING root/gtmessages.ml (file already exists)"

else
${echo} "x - extracting root/gtmessages.ml (text)"
  sed 's/^X//' << 'SHAR_EOF' > 'root/gtmessages.ml' &&
(*
X * Copyright (C) 2006-2009 Citrix Systems Inc.
X *
X * This program is free software; you can redistribute it and/or modify
X * it under the terms of the GNU Lesser General Public License as published
X * by the Free Software Foundation; version 2.1 only. with the special
X * exception on linking described in file LICENSE.
X *
X * This program is distributed in the hope that it will be useful,
X * but WITHOUT ANY WARRANTY; without even the implied warranty of
X * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
X * GNU Lesser General Public License for more details.
X *)
type message = 
X    (* Guest to Dom0 messages *)
X  | CmdResult of string  
X
X    (* Dom0 to guest messages *) 
X  | CheckCD of string list  (* Check we've got connected cds *)
X  | CheckVIF of string (* Check one device exists *)
X  | CheckDisks of string list
X  | CheckMountDisks of string list
X  | SetupTestDisk of string
X  | Shutdown of int
X  | Reboot of int
X  | Crash
X  | Test
X  | CheckCDFail of string list
X
SHAR_EOF
  (set 20 16 05 09 10 34 56 'root/gtmessages.ml'
   eval "${shar_touch}") && \
  chmod 0644 'root/gtmessages.ml'
if test $? -ne 0
then ${echo} "restore of root/gtmessages.ml failed"
fi
  if ${md5check}
  then (
       ${MD5SUM} -c >/dev/null 2>&1 || ${echo} 'root/gtmessages.ml': 'MD5 check failed'
       ) << \SHAR_EOF
eaf8b8e87541cf2f485a321db850d17f  root/gtmessages.ml
SHAR_EOF

else
test `LC_ALL=C wc -c < 'root/gtmessages.ml'` -ne 992 && \
  ${echo} "restoration warning:  size of 'root/gtmessages.ml' is not 992"
  fi
fi
# ============= root/gtserver_linux.ml ==============
if test -n "${keep_file}" && test -f 'root/gtserver_linux.ml'
then
${echo} "x - SKIPPING root/gtserver_linux.ml (file already exists)"

else
${echo} "x - extracting root/gtserver_linux.ml (text)"
  sed 's/^X//' << 'SHAR_EOF' > 'root/gtserver_linux.ml' &&
(*
X * Copyright (C) 2006-2009 Citrix Systems Inc.
X *
X * This program is free software; you can redistribute it and/or modify
X * it under the terms of the GNU Lesser General Public License as published
X * by the Free Software Foundation; version 2.1 only. with the special
X * exception on linking described in file LICENSE.
X *
X * This program is distributed in the hope that it will be useful,
X * but WITHOUT ANY WARRANTY; without even the implied warranty of
X * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
X * GNU Lesser General Public License for more details.
X *)
X
module Protocol = Gtcomms.Make_Protocol (struct type t=Gtmessages.message end)
module Client = Gtcomms.Client (Protocol)
module Server = Gtcomms.Server (Protocol)
X
module GuestOp=Gtlinuxops
X
open Gtmessages
X
class server n np =
X  object (self)
X    inherit [message] Server.server n np
X
X    method shutdown s timeout =
X      self#send s (CmdResult "Shutdown called!");
X      ignore(GuestOp.shutdown timeout)
X
X    method reboot s timeout =
X      self#send s (CmdResult "Reboot called!");
X      ignore(GuestOp.reboot timeout)
X
X    method crash s =
X      ignore(GuestOp.crash ());
X      self#send s (CmdResult "You might not get this...")
X	
X    method test s =
X      self#send s (CmdResult "Test worked OK!")
X
X    method checkcds s devices =
X      self#send s (GuestOp.checkcds devices true)
X	
X    method checkcdsfail s devices =
X      self#send s (GuestOp.checkcds devices false)
X
X    method checkvif s device =
X      self#send s (GuestOp.checkvifs device)  
X	
X    method checkdisks s devices =
X      self#send s (GuestOp.checkdisks devices)
X
X    method checkmountdisks s devices =
X      self#send s (GuestOp.checkmountdisks devices)
X
X    method setuptestdisk s device =
X      self#send s (GuestOp.setuptestdisk device)
X
X    method process s = 
X      try
X	begin
X	  match self#receive s with
X              Shutdown timeout -> self#shutdown s timeout
X	    | Reboot timeout -> self#reboot s timeout
X	    | Test -> self#test s 
X	    | Crash -> self#crash s
X	    | CheckCD devs -> self#checkcds s devs
X	    | CheckVIF dev -> self#checkvif s dev
X	    | CheckDisks devs -> self#checkdisks s devs
X	    | CheckMountDisks devs -> self#checkmountdisks s devs
X	    | SetupTestDisk dev -> self#setuptestdisk s dev
X	    | CheckCDFail devs -> self#checkcdsfail s devs
X	    | _ -> ()
X	end;
X	Unix.close s
X      with
X	  e -> GuestOp.logerr (Printexc.to_string e)
X	
X  end
X
let _ =
X  let port = 8085 in
X  let s = new server port 1 in
X  s#start
X
SHAR_EOF
  (set 20 16 05 09 10 34 56 'root/gtserver_linux.ml'
   eval "${shar_touch}") && \
  chmod 0644 'root/gtserver_linux.ml'
if test $? -ne 0
then ${echo} "restore of root/gtserver_linux.ml failed"
fi
  if ${md5check}
  then (
       ${MD5SUM} -c >/dev/null 2>&1 || ${echo} 'root/gtserver_linux.ml': 'MD5 check failed'
       ) << \SHAR_EOF
7ef6b029c128bf0d056ad8a2ad8e3bc1  root/gtserver_linux.ml
SHAR_EOF

else
test `LC_ALL=C wc -c < 'root/gtserver_linux.ml'` -ne 2506 && \
  ${echo} "restoration warning:  size of 'root/gtserver_linux.ml' is not 2506"
  fi
fi
# ============= root/gtlinuxops.ml ==============
if test -n "${keep_file}" && test -f 'root/gtlinuxops.ml'
then
${echo} "x - SKIPPING root/gtlinuxops.ml (file already exists)"

else
${echo} "x - extracting root/gtlinuxops.ml (text)"
  sed 's/^X//' << 'SHAR_EOF' > 'root/gtlinuxops.ml' &&
(*
X * Copyright (C) 2006-2009 Citrix Systems Inc.
X *
X * This program is free software; you can redistribute it and/or modify
X * it under the terms of the GNU Lesser General Public License as published
X * by the Free Software Foundation; version 2.1 only. with the special
X * exception on linking described in file LICENSE.
X *
X * This program is distributed in the hope that it will be useful,
X * but WITHOUT ANY WARRANTY; without even the implied warranty of
X * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
X * GNU Lesser General Public License for more details.
X *)
X
let rec read ic cur = 
X  try
X    let line = input_line ic in
X    read ic (line::cur) 
X  with
X    _ -> List.rev cur
X
let shutdown timeout =
X  (* Timeout measured in mins! ignore timeout then :) *)
X  let _ = Unix.open_process_in "poweroff" in
X  Gtmessages.CmdResult ""
X
let reboot timeout =
X  (* Timeout measured in mins! ignore timeout then :) *)
X  let _ = Unix.open_process_in "reboot" in
X  Gtmessages.CmdResult ""
X
let crash () =
X  ignore(Sys.command "echo 1 > /proc/sys/kernel/panic_on_oops");
X  ignore(Sys.command "dd if=/dev/zero of=/dev/mem");
X  Gtmessages.CmdResult ""
X
let trytwice fn =
X  let result = fn () in
X  if result <> 0 then
X    begin
X      Unix.sleep 5;
X      fn ()
X    end
X  else result
X
let checkdevice device =
X  let cmd () = Sys.command ("test -e /dev/"^device) in
X  trytwice cmd
X    
let checkcds devices checkdev =
X  let is_pv = try ignore(Unix.stat "/proc/xen"); true with _ -> false in
X  let devmap = 
X    if is_pv then ["2","xvdc";"3","xvdd"] else ["2","hdc";"3","hdd"]
X  in  
X  let results = List.map (fun dev -> 
X    let ldevice = List.assoc dev devmap in
X    if checkdev then ignore(checkdevice ldevice);
X    ignore(Sys.command ("mkdir -p /mnt/cdrom0"));
X    ignore(Sys.command ("mount /dev/"^ldevice^" /mnt/cdrom0"));
X    let ic = Unix.open_process_in "ls /mnt/cdrom0" in
X    let result = read ic [] in
X    ignore(Sys.command "umount /mnt/cdrom0");
X    dev ^ ":\n\n" ^ (String.concat "\n" result)) devices in
X  Gtmessages.CmdResult (String.concat "\n" results)
X
let checkdisks devices =
X  let results = List.map (fun dev -> 
X    ignore(checkdevice dev);
X    let ldevice = dev in
X    let ic = Unix.open_process_in ("fdisk /dev/"^ldevice) in
X    let result = read ic [] in
X    String.concat "\n" result) devices in
X  Gtmessages.CmdResult (String.concat "\n" results)
X
let setuptestdisk device = (* Device is in this case a full sda or hda or whatever *)
X  ignore(checkdevice device);
X  let (ic,oc)=Unix.open_process ("sfdisk /dev/"^device) in
X  Printf.fprintf oc ",,c;\n";
X  flush_all ();
X  close_out oc;
X  ignore(read ic []);
X  ignore(Sys.command ("mkdosfs /dev/"^device^"1"));
X  ignore(Sys.command "mkdir -p /mnt/disk");
X  ignore(Sys.command ("mount /dev/"^device^"1 /mnt/disk"));
X  ignore(Sys.command ("touch /mnt/disk/testing"));
X  ignore(Sys.command ("umount /mnt/disk"));
X  Gtmessages.CmdResult "OK"
X  
let checkmountdisks devices =
X  (* Don't know whether we're pv (sdx) or hvm (hdx), so try both *)
X  let mapfn dev =
X    let ldevice = dev in
X    ignore(Sys.command "mkdir -p /mnt/disk");
X    ignore(Sys.command (Printf.sprintf "mount /dev/%s /mnt/disk" ldevice));
X    let ic = Unix.open_process_in "ls /mnt/disk" in
X    let result = read ic [] in
X    ignore(Sys.command "umount /mnt/disk");
X    String.concat "\n" result in
X  let results = List.map mapfn devices in
X  Gtmessages.CmdResult (String.concat "\n" results)
X
let checkvifs device =
X  let map = [("0","eth0");("1","eth1");("2","eth2")] in
X  let hostdevice = List.assoc device map in
X  let ic = Unix.open_process_in ("ifconfig "^hostdevice) in
X  let lines = read ic [] in
X  Gtmessages.CmdResult (List.hd lines)
X
let logerr msg =
X  let oc = open_out "/var/log/gtserver.log" in
X  Printf.fprintf oc "%s\n" msg;
X  close_out oc
X
X
X  
X
SHAR_EOF
  (set 20 16 05 09 10 34 56 'root/gtlinuxops.ml'
   eval "${shar_touch}") && \
  chmod 0644 'root/gtlinuxops.ml'
if test $? -ne 0
then ${echo} "restore of root/gtlinuxops.ml failed"
fi
  if ${md5check}
  then (
       ${MD5SUM} -c >/dev/null 2>&1 || ${echo} 'root/gtlinuxops.ml': 'MD5 check failed'
       ) << \SHAR_EOF
c25129c022e459455239ef1c1380e9b9  root/gtlinuxops.ml
SHAR_EOF

else
test `LC_ALL=C wc -c < 'root/gtlinuxops.ml'` -ne 3806 && \
  ${echo} "restoration warning:  size of 'root/gtlinuxops.ml' is not 3806"
  fi
fi
if rm -fr ${lock_dir}
then ${echo} "x - removed lock directory ${lock_dir}."
else ${echo} "x - failed to remove lock directory ${lock_dir}."
     exit 1
fi
exit 0
